/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Model179
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Model179 {
  @SerializedName("product_code")
  private String productCode = null;

  @SerializedName("quote_code")
  private String quoteCode = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("type")
  private String type = null;

  @SerializedName("guarantees")
  private Model170 guarantees = null;

  @SerializedName("prices")
  private Model172 prices = null;

  @SerializedName("attachments")
  private Model174 attachments = null;

  @SerializedName("consents")
  private Model176 consents = null;

  @SerializedName("disclaimers")
  private Disclaimers disclaimers = null;

  @SerializedName("payment_periodicities")
  private Model178 paymentPeriodicities = null;

  public Model179 productCode(String productCode) {
    this.productCode = productCode;
    return this;
  }

   /**
   * Product code.
   * @return productCode
  **/
  @ApiModelProperty(example = "PRDADVANCE", required = true, value = "Product code.")
  public String getProductCode() {
    return productCode;
  }

  public void setProductCode(String productCode) {
    this.productCode = productCode;
  }

  public Model179 quoteCode(String quoteCode) {
    this.quoteCode = quoteCode;
    return this;
  }

   /**
   * Quote code.
   * @return quoteCode
  **/
  @ApiModelProperty(example = "d41d8cd98f00b204e9800998ecf8427e", required = true, value = "Quote code.")
  public String getQuoteCode() {
    return quoteCode;
  }

  public void setQuoteCode(String quoteCode) {
    this.quoteCode = quoteCode;
  }

  public Model179 name(String name) {
    this.name = name;
    return this;
  }

   /**
   * name
   * @return name
  **/
  @ApiModelProperty(example = "Advanced", value = "name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Model179 description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Product marketing description
   * @return description
  **/
  @ApiModelProperty(example = "Advanced for more guarantees", value = "Product marketing description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Model179 type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Product type. Expected values (MULTI_APPLIANCE, MONO_APPLIANCE)
   * @return type
  **/
  @ApiModelProperty(example = "MONO_APPLIANCE", value = "Product type. Expected values (MULTI_APPLIANCE, MONO_APPLIANCE)")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public Model179 guarantees(Model170 guarantees) {
    this.guarantees = guarantees;
    return this;
  }

   /**
   * Get guarantees
   * @return guarantees
  **/
  @ApiModelProperty(required = true, value = "")
  public Model170 getGuarantees() {
    return guarantees;
  }

  public void setGuarantees(Model170 guarantees) {
    this.guarantees = guarantees;
  }

  public Model179 prices(Model172 prices) {
    this.prices = prices;
    return this;
  }

   /**
   * Get prices
   * @return prices
  **/
  @ApiModelProperty(required = true, value = "")
  public Model172 getPrices() {
    return prices;
  }

  public void setPrices(Model172 prices) {
    this.prices = prices;
  }

  public Model179 attachments(Model174 attachments) {
    this.attachments = attachments;
    return this;
  }

   /**
   * Get attachments
   * @return attachments
  **/
  @ApiModelProperty(value = "")
  public Model174 getAttachments() {
    return attachments;
  }

  public void setAttachments(Model174 attachments) {
    this.attachments = attachments;
  }

  public Model179 consents(Model176 consents) {
    this.consents = consents;
    return this;
  }

   /**
   * Get consents
   * @return consents
  **/
  @ApiModelProperty(value = "")
  public Model176 getConsents() {
    return consents;
  }

  public void setConsents(Model176 consents) {
    this.consents = consents;
  }

  public Model179 disclaimers(Disclaimers disclaimers) {
    this.disclaimers = disclaimers;
    return this;
  }

   /**
   * Get disclaimers
   * @return disclaimers
  **/
  @ApiModelProperty(value = "")
  public Disclaimers getDisclaimers() {
    return disclaimers;
  }

  public void setDisclaimers(Disclaimers disclaimers) {
    this.disclaimers = disclaimers;
  }

  public Model179 paymentPeriodicities(Model178 paymentPeriodicities) {
    this.paymentPeriodicities = paymentPeriodicities;
    return this;
  }

   /**
   * Get paymentPeriodicities
   * @return paymentPeriodicities
  **/
  @ApiModelProperty(value = "")
  public Model178 getPaymentPeriodicities() {
    return paymentPeriodicities;
  }

  public void setPaymentPeriodicities(Model178 paymentPeriodicities) {
    this.paymentPeriodicities = paymentPeriodicities;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Model179 model179 = (Model179) o;
    return Objects.equals(this.productCode, model179.productCode) &&
        Objects.equals(this.quoteCode, model179.quoteCode) &&
        Objects.equals(this.name, model179.name) &&
        Objects.equals(this.description, model179.description) &&
        Objects.equals(this.type, model179.type) &&
        Objects.equals(this.guarantees, model179.guarantees) &&
        Objects.equals(this.prices, model179.prices) &&
        Objects.equals(this.attachments, model179.attachments) &&
        Objects.equals(this.consents, model179.consents) &&
        Objects.equals(this.disclaimers, model179.disclaimers) &&
        Objects.equals(this.paymentPeriodicities, model179.paymentPeriodicities);
  }

  @Override
  public int hashCode() {
    return Objects.hash(productCode, quoteCode, name, description, type, guarantees, prices, attachments, consents, disclaimers, paymentPeriodicities);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Model179 {\n");
    
    sb.append("    productCode: ").append(toIndentedString(productCode)).append("\n");
    sb.append("    quoteCode: ").append(toIndentedString(quoteCode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    guarantees: ").append(toIndentedString(guarantees)).append("\n");
    sb.append("    prices: ").append(toIndentedString(prices)).append("\n");
    sb.append("    attachments: ").append(toIndentedString(attachments)).append("\n");
    sb.append("    consents: ").append(toIndentedString(consents)).append("\n");
    sb.append("    disclaimers: ").append(toIndentedString(disclaimers)).append("\n");
    sb.append("    paymentPeriodicities: ").append(toIndentedString(paymentPeriodicities)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

